stages:
    - build
    - release

variables:
    BRANCH_NAME: "odroidg12-4.9.y"
    TAG: "4.9.230-96"

build:
    stage: build
    image: registry.gitlab.com/therackio/build-tools/helper-images/linux-kernal-builder-arm64:latest
    tags:
        - arm64-onprem-public
    only:
        refs:
            - master
    variables:
        DEBIAN_FRONTEND: "noninteractive"
    script:
        - set eux
        - mkdir ./dist
        - export BASEDIR=$(pwd)
        - export INSTALL_MOD_PATH=$BASEDIR/dist
        - echo $INSTALL_MOD_PATH
        - git clone --depth 1 https://github.com/hardkernel/linux.git -b $BRANCH_NAME
        - cd linux
        - git fetch origin refs/tags/$TAG:refs/tags/$TAG
        - git checkout tags/$TAG
        - make odroidg12_defconfig
        - cat ../KERNEL_FLAGS >> ./.config
        - make olddefconfig
        - make -j $(nproc)
        - make modules_install
        - cp -f arch/arm64/boot/Image.gz arch/arm64/boot/dts/amlogic/meson64_odroidn2.dtb $INSTALL_MOD_PATH
        - sync
        - cd ..
        - cd ./dist
        - tar -zcf modules.tar.gz lib
        - rm -rf ./lib
    artifacts:
        paths:
            - dist/
        expire_in: 6 hours

release:
    stage: release
    image: registry.gitlab.com/therackio/build-tools/helper-images/gitlab-releaser-arm64:latest
    tags:
        - arm64-onprem-public
    only:
        refs:
            - master
    dependencies:
        - build
    script:
        - export IMAGE_KEY=$CI_PROJECT_PATH/$TAG/Image.gz
        - export DTB_KEY=$CI_PROJECT_PATH/$TAG/meson64_odroidn2.dtb
        - export MODULES_KEY=$CI_PROJECT_PATH/$TAG/modules.tar.gz
        - aws s3 cp ./dist/Image.gz s3://$RELEASE_BUCKET/$IMAGE_KEY --endpoint-url=$RELEASE_S3_ENDPOINT
        - aws s3 cp ./dist/meson64_odroidn2.dtb s3://$RELEASE_BUCKET/$DTB_KEY --endpoint-url=$RELEASE_S3_ENDPOINT
        - aws s3 cp ./dist/modules.tar.gz s3://$RELEASE_BUCKET/$MODULES_KEY --endpoint-url=$RELEASE_S3_ENDPOINT
        - release-cli create --name "$TAG" --description "Hardkernel Linux - $TAG.  Compiled natively on ARM64 with additional config flags for advanced Docker features." --tag-name "$TAG" --ref $CI_COMMIT_SHA --released-at "$(date -u +"%Y-%m-%dT%H:%M:%SZ")" --assets-links-name "Image.gz" --assets-links-url "$RELEASE_S3_ENDPOINT/$RELEASE_BUCKET/$IMAGE_KEY" --assets-links-name "meson64_odroidn2.dtb" --assets-links-url "$RELEASE_S3_ENDPOINT/$RELEASE_BUCKET/$DTB_KEY" --assets-links-name "modules.tar.gz" --assets-links-url "$RELEASE_S3_ENDPOINT/$RELEASE_BUCKET/$MODULES_KEY"
